#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <bios.h>

class list {
public:
  unsigned char normal_text_color;
  unsigned char sel_text_color;
  unsigned char ramka_color;
  unsigned char title_color;
  unsigned char mode;
  char left, top, height, width;
  unsigned char title[20];
  void init(char filename[80], unsigned char _title[20]);
  void run(void);
private:
  void output(int n);
  void ramka(void);
  void save(void);
  void restore(void);
  void load(char filename[80]);
  unsigned int (far *screen)[80];
  unsigned int buf[25][80];
  unsigned int save_buf[25][80];
  unsigned char buffer[300][80];
  int length, posx, posy, r;
};

void list::init(char filename[80], unsigned char _title[20])
{
  normal_text_color=0x1E;
  sel_text_color=0x70;
  ramka_color=0x1F;
  title_color=0x70;
  strcpy(title, _title);
  top=5;
  left=20;
  height=15;
  width=40;
  screen=(unsigned int (far *)[80])MK_FP(0xB800, 0);
  save();
  load(filename);
  posx=0;
  posy=0;
  r=0;
  mode=0;
}

void list::save(void)
{
  int i, j;
  for (i=0;i<80;i++)
    for (j=0;j<25;j++)
      save_buf[j][i]=screen[j][i];
}

void list::restore(void)
{
  int i, j;
  for (i=0;i<80;i++)
    for (j=0;j<25;j++)
      buf[j][i]=save_buf[j][i];
}

void list::output(int n)
{
  int i, j;
  restore();
  ramka();
  for (i=0;i<width-1;i++)
    for (j=posy;j<posy+height-1;j++) {
      if ((j-posy)==n)
        buf[j-posy+top+1][i+left+1]=buffer[j][i+posx]+256*sel_text_color;
          else
            buf[j-posy+top+1][i+left+1]=buffer[j][i+posx]+256*normal_text_color;
    }

  for (i=0;i<80;i++)
    for (j=0;j<25;j++)
      screen[j][i]=buf[j][i];
}

void list::ramka(void)
{
  int i, j, X1, Y1, X2, Y2;
  unsigned int ATTR=256*ramka_color;

  X1=left;
  Y1=top;
  X2=left+width;
  Y2=top+height;

  for (i=X1;i<X2+1;i++)
    for (j=Y1;j<Y2+1;j++)
      buf[j][i]=' '+ATTR;

  for (i=X1+1;i<X2;i++) {
    buf[Y1][i]=205+ATTR;
    buf[Y2][i]=205+ATTR;
  }

  for (i=Y1+1;i<Y2;i++) {
    buf[i][X1]=186+ATTR;
    buf[i][X2]=186+ATTR;
  }

  buf[Y1][X1]=201+ATTR;
  buf[Y1][X2]=187+ATTR;
  buf[Y2][X1]=200+ATTR;
  buf[Y2][X2]=188+ATTR;

  j=width/2-strlen(title)/2+left;
  for (i=0;i<strlen(title);i++)
    buf[top][j+i]=title[i]+256*title_color;
}

void list::load(char filename[80])
{
  FILE *f;
  int i, j;
  char c;
  for (i=0;i<300;i++)
    for (j=0;j<80;j++)
      buffer[i][j]=32;
  i=0;
  j=0;
  f=fopen(filename, "rb");
  do
  {
    c=getc(f);
    if (c==13) {
      i++;
      j=0;
    }

    if ((c!=0x0A)*(c!=13))
    {
      buffer[i][j]=c;
      j++;
    }

  } while ((!feof(f))*(i<300));
  length=i;
}

void list::run(void)
{
  int i;
  char ch;
  i=r;
  output(i);
  do
  {
    if (mode==0)
    {
      ch=getch();
      if (ch==80) i++;
      if (i>height-2) {
        posy++;
        if (posy>length-height+2) posy=length-height+2;
        i=height-2;
      }
      if (i>length) i=length;
      if (ch==72) i--;
      if (i<0) {
        i=0;
        posy--;
        if (posy<0) posy=0;
      }
      if (ch==81) {
        if (i==height-2) {
          posy=posy+height-2;
          if (posy>length-height+2) posy=length-height+2;
        }
          else i=height-2;
        if (i>length) i=length;
      }
      if (ch==73) {
        if (i==0) {
          posy=posy-height-2;
          if (posy<0) posy=0;
        }
          else i=0;
      }
      if (ch==77) posx++;
      if (posx>79-width-2) posx=79-width-2;
      if (ch==75) posx--;
      if (posx<0) posx=0;
      if (ch==79) posx=79-width-2;
      if (ch==71) posx=0;
      if (ch==63) {
        mode=1;
        ramka_color=0x1E;
      }
      output(i);
    }
    else
      do
      {
        ch=getch();
        if ((ch==77)*(!bioskey(2))) left++;
        if (left>79-width) left=79-width;
        if ((ch==75)*(!bioskey(2))) left--;
        if (left<0) left=0;
        if ((ch==80)*(!bioskey(2))) top++;
        if (top>24-height) top=24-height;
        if ((ch==72)*(!bioskey(2)))  top--;
        if (top<0) top=0;
        if ((ch==77)*(bioskey(2))) width++;
        if (width+left>79) width=79-left;
        if ((ch==75)*(bioskey(2))) width--;
        if (width<5) width=5;
        if ((ch==80)*(bioskey(2))) height++;
        if (height+top>24) height=24-top;
        if ((ch==72)*(bioskey(2))) height--;
        if (height<5) height=5;
        if (ch==13) {
          mode=0;
          ramka_color=0x1F;
        }
        if (i>height-2) i=height-2;
        output(i);
      } while (ch!=13);
  } while(ch!=68);
}

main(void)
{
  list a;
  a.init("list.cpp", " MOV");
  a.run();
}