include macro.lib
.186
code segment
  org 100h
  assume cs:code, ds:code, ss:code

main:

  jmp begin

item1 db '1. $'
item2 db '2. ⠭$'
item3 db '3. $'
item4 db '4. $'
item5 db '5.   ⥯$'
item6 db '6. 宦 䠪ਠ$'
item7 db '7. 室  DOS$'
choice db ' 롮: $'
message1 db ' ࢮ ᫮: $'
message2 db ' ஥ ᫮: $'
message3 db '᫮  ࠢ쭮!$'
message4 db ' 㢥७ [Y/N]? $'
message5 db ': $'
message6 db '⮪: $'
op1 dw ?
op2 dw ?

begin:

_menu:

  mov ax, 00
  call cursor
  call _cls
  call show_title
  call menu

_choice:

  mov ah, 00
  int 16h

  cmp al, '1'
  je l1
  cmp al, '2'
  je l2
  cmp al, '3'
  je l3
  cmp al, '4'
  je l4
  cmp al, '5'
  je l5
  cmp al, '6'
  je l6
  cmp al, '7'
  je l7
  jmp _choice
l1:
  call addition
  jmp _menu
l2:
  call subtraction
  jmp _menu
l3:
  call multipling
  jmp _menu
l4:
  call dividing
  jmp _menu
l5:
  call step
  jmp _menu
l6:
  call factorial
  jmp _menu
l7:
  call exit
  jmp _menu

  mov ax, 4C00h
  int 21h

include title.asm
include procs.asm

menu proc near
  call new_line
  mov ah, 09
  lea dx, item1
  int 21h
  call new_line
  lea dx, item2
  int 21h
  call new_line
  lea dx, item3
  int 21h
  call new_line
  lea dx, item4
  int 21h
  call new_line
  lea dx, item5
  int 21h
  call new_line
  lea dx, item6
  int 21h
  call new_line
  lea dx, item7
  int 21h
  call new_line
  call new_line
  lea dx, choice
  int 21h
  ret
menu endp

addition proc near
  call input
  add cx, bx
  call result
  ret
addition endp

subtraction proc near
  call input
  sub cx, bx
  call result
  ret
subtraction endp

multipling proc near
  call input
  mov ax, cx
  imul bx
  mov cx, ax
  call result
  ret
multipling endp

dividing proc near
  call input
  cmp bx, 0
  je l15
  jmp l16
l15:
  call error
  jmp l17
l16:
  mov ax, cx
  mov dx, 00
  idiv bx
  mov cx, ax
  call result
  push dx
  call new_line
  mov ah, 09
  lea dx, message6
  int 21h
  pop dx
  mov ax, dx
  print_number
  mov ax, 00
  int 16h
l17:
  ret
dividing endp

step proc near
  call input
  mov ax, cx
  mov cx, bx
  mov bx, ax
  dec cx
  cmp cx, -1
  jl l18
  jmp l19
l18:
  call error
  jmp l20
l19:
  cmp cx, -1
  je l12
  jmp l13
l12:
  mov ax, 1
  jmp l11
l13:
  cmp cx, 0
  je l11
l10:
  imul bx
  loop l10
l11:
  mov cx, ax
  call result
l20:
  ret
step endp

factorial proc near
  call new_line
  call new_line
  mov ah, 09
  lea dx, message1
  int 21h
  key_$2bin
  cmp ax, 0
  jl l21
  jmp l22
l21:
  call error
  jmp l23
l22:
  cmp ax, 1
  je l24
  jmp l25
l24:
  mov ax, 1
  jmp l26
l25:
  mov cx, ax
  dec cx
  mov bx, 1
  mov ax, 1
l14:
  inc bx
  imul bx
  loop l14
l26:
  mov cx, ax
  call result
l23:
  ret
factorial endp

input proc near
  call new_line
  call new_line
  mov ah, 09
  lea dx, message1
  int 21h
  key_$2bin
  mov cx, ax
  call new_line
  mov ah, 09
  lea dx, message2
  int 21h
  key_$2bin
  mov bx, ax
  ret
input endp

result proc near
  pusha
  call new_line
  mov ah, 09
  lea dx, message5
  int 21h
  mov ax, cx
  print_number
  mov ax, 00
  int 16h
  popa
  ret
result endp

error proc near
  call new_line
  mov ah, 09
  lea dx, message3
  int 21h
  mov ah, 00
  int 16h
  ret
error endp

code ends
  end main